<script setup lang="ts">
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';
  import { ShippingMethod } from '@shopware-pwa/types';

  const props = defineProps<{
    loading?: boolean;
    options: ShippingMethod[];
    modelValue?: string;
    updatingId?: string;
  }>();

  const emit = defineEmits(['update:modelValue']);

  const selectedValue = ref<string>();

  syncRefs(toRef(props, 'modelValue'), selectedValue);

  const updateValue = (id: string) => {
    if (selectedValue.value !== id) {
      selectedValue.value = id;
      emit('update:modelValue', id);
    }
  };
</script>

<template>
  <slot />
  <div class="border-border rounded-2 border bg-white">
    <SwRadio v-if="loading" :loading="loading" class="p-4" />

    <template v-else>
      <SwRadio
        v-for="(option, i) in options"
        :key="option.id"
        :checked="option.id === selectedValue"
        :loading="option.id === updatingId"
        :disabled="!!updatingId"
        class="border-border hover:bg-background-raised p-4"
        :class="{ 'border-t': i !== 0 }"
        @update:model-value="updateValue(option.id)"
      >
        <div class="-mt-1 ml-2 flex flex-1 items-center justify-between">
          <div>
            <SwLabel as="span" class="!text-information text-sm/6">
              {{ getTranslatedProperty(option, 'name') }}
            </SwLabel>

            <p class="text-(information-subdued xs) font-medium">
              {{ getTranslatedProperty(option, 'description') }}
            </p>
          </div>

          <img v-if="option.media?.url" :src="option.media.url" class="h-8 w-20 object-contain" />
        </div>
      </SwRadio>
    </template>
  </div>
</template>
